﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win;

namespace WindowsFormsApplication115
{
    public partial class Form1 : Form
    {
        List<TextBox> ABC = new List<TextBox>();
        List<TextBox> XYZ = new List<TextBox>();

        public Form1()
        {
            InitializeComponent();

            ultraValidator1.NotificationSettings.Action = Infragistics.Win.Misc.NotificationAction.Image;
            ABC.Add(textBoxA);
            ABC.Add(textBoxB);
            ABC.Add(textBoxC);

            XYZ.Add(textBoxX);
            XYZ.Add(textBoxY);
            XYZ.Add(textBoxZ);

            foreach (Control control in this.Controls)
            {
                control.CausesValidation = true;
            }
        }


        private void MakeValueRequired(UltraValidator ultraValidator, List<TextBox> textFields)
        {
            ultraValidator.ValidationGroups.Clear();
            ValidationGroup requiredFieldsGroup = ultraValidator.ValidationGroups.Add("Required");

            int count = textFields != null ? textFields.Count : 0;
            for (int i = 0; i < count; i++)
            {
                TextBox textBox = textFields[i];
                ValidationSettings validationSettings = ultraValidator.GetValidationSettings(textBox);
                validationSettings.Reset();
                validationSettings.ValidationGroup = requiredFieldsGroup;
                validationSettings.ValidationTrigger = ValidationTrigger.Programmatic;
                validationSettings.ValidationPropertyName = "Text";
                validationSettings.IsRequired = true;
            }

            ultraValidator.ValidationError += new ValidationErrorHandler(this.OnRequiredFieldValidationError);
        }

        private void ValidateRequired(ValidationGroup requiredFieldsGroup)
        {
            UltraValidator ultraValidator = requiredFieldsGroup.UltraValidator;
            ultraValidator.Validate(requiredFieldsGroup, true, false);
        }


        private void OnRequiredFieldValidationError(object sender, ValidationErrorEventArgs e)
        {
            hasError = true;
        }

        bool hasError = false;


        private void ultraOptionSet1_ValueChanged(object sender, EventArgs e)
        {
            switch (ultraOptionSet1.Value.ToString())
            {
                case "visible": ultraButton1.Show();
                    clearNotRequired(ultraValidator1, ABC);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    MakeValueRequired(ultraValidator1, XYZ);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    ultraValidator1.ResetValidationGroups();


                    break;
                case "hidden": ultraButton1.Hide();
                    clearNotRequired(ultraValidator1, XYZ);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    MakeValueRequired(ultraValidator1, ABC);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    ultraValidator1.ResetValidationGroups();

                    break;
            }
        }

        private void clearNotRequired(UltraValidator ultraValidator, List<TextBox> textFields)
        {
            ultraValidator.ValidationGroups.Clear();
            ValidationGroup requiredFieldsGroup = ultraValidator.ValidationGroups.Add("Required");

            int count = textFields != null ? textFields.Count : 0;
            for (int i = 0; i < count; i++)
            {
                TextBox textBox = textFields[i];
                ValidationSettings validationSettings = ultraValidator.GetValidationSettings(textBox);
                validationSettings.Reset();
                validationSettings.ValidationGroup = requiredFieldsGroup;
                validationSettings.IsRequired = false;
            }
        }

        private void ultraButton1_VisibleChanged(object sender, EventArgs e)
        {

            if (!ultraButton1.Visible && hasLoaded)
            {
                MakeValueRequired(ultraValidator1, ABC);
                ValidateRequired(ultraValidator1.ValidationGroups[0]);
                ultraValidator1.ResetValidationGroups();
            }

            else if (ultraButton1.Visible && hasLoaded)
            {
                MakeValueRequired(ultraValidator1, XYZ);
                ValidateRequired(ultraValidator1.ValidationGroups[0]);
                ultraValidator1.ResetValidationGroups();
            }
        }


        bool hasLoaded = false;

        private void Form1_Load(object sender, EventArgs e)
        {
            hasLoaded = true;
        }

        private void ultraValidator1_Validating(object sender, ValidatingEventArgs e)
        {
            if (e.IsValid)
            {
                hasError = false;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (hasError)
            {
                e.Cancel = true;
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            switch (ultraOptionSet1.Value.ToString())
            {
                case "visible": ultraButton1.Show();
                    clearNotRequired(ultraValidator1, ABC);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    MakeValueRequired(ultraValidator1, XYZ);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    ultraValidator1.ResetValidationGroups();


                    break;
                case "hidden": ultraButton1.Hide();
                    clearNotRequired(ultraValidator1, XYZ);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    MakeValueRequired(ultraValidator1, ABC);
                    ValidateRequired(ultraValidator1.ValidationGroups[0]);

                    ultraValidator1.ResetValidationGroups();

                    break;
            }
        }
    }
}